# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateCloudAccountVsphereSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'host_name': 'str',
        'accept_self_signed_certificate': 'bool',
        'associated_cloud_account_ids': 'list[str]',
        'associated_mobility_cloud_account_ids': 'dict(str, str)',
        'dcid': 'str',
        'username': 'str',
        'password': 'str',
        'regions': 'list[IaasapicloudaccountsvsphereRegions]',
        'create_default_zones': 'bool',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'certificate_info': 'IaasapiintegrationsCertificateInfo',
        'environment': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'host_name': 'hostName',
        'accept_self_signed_certificate': 'acceptSelfSignedCertificate',
        'associated_cloud_account_ids': 'associatedCloudAccountIds',
        'associated_mobility_cloud_account_ids': 'associatedMobilityCloudAccountIds',
        'dcid': 'dcid',
        'username': 'username',
        'password': 'password',
        'regions': 'regions',
        'create_default_zones': 'createDefaultZones',
        'tags': 'tags',
        'certificate_info': 'certificateInfo',
        'environment': 'environment'
    }

    def __init__(self, name=None, description=None, host_name=None, accept_self_signed_certificate=None, associated_cloud_account_ids=None, associated_mobility_cloud_account_ids=None, dcid=None, username=None, password=None, regions=None, create_default_zones=None, tags=None, certificate_info=None, environment=None):  # noqa: E501
        """UpdateCloudAccountVsphereSpecification - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._host_name = None
        self._accept_self_signed_certificate = None
        self._associated_cloud_account_ids = None
        self._associated_mobility_cloud_account_ids = None
        self._dcid = None
        self._username = None
        self._password = None
        self._regions = None
        self._create_default_zones = None
        self._tags = None
        self._certificate_info = None
        self._environment = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        self.host_name = host_name
        if accept_self_signed_certificate is not None:
            self.accept_self_signed_certificate = accept_self_signed_certificate
        if associated_cloud_account_ids is not None:
            self.associated_cloud_account_ids = associated_cloud_account_ids
        if associated_mobility_cloud_account_ids is not None:
            self.associated_mobility_cloud_account_ids = associated_mobility_cloud_account_ids
        if dcid is not None:
            self.dcid = dcid
        if username is not None:
            self.username = username
        if password is not None:
            self.password = password
        self.regions = regions
        if create_default_zones is not None:
            self.create_default_zones = create_default_zones
        if tags is not None:
            self.tags = tags
        if certificate_info is not None:
            self.certificate_info = certificate_info
        if environment is not None:
            self.environment = environment

    @property
    def name(self):
        """Gets the name of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UpdateCloudAccountVsphereSpecification.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdateCloudAccountVsphereSpecification.

        A human-friendly description.  # noqa: E501

        :param description: The description of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def host_name(self):
        """Gets the host_name of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        Host name for the vSphere endpoint  # noqa: E501

        :return: The host_name of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """Sets the host_name of this UpdateCloudAccountVsphereSpecification.

        Host name for the vSphere endpoint  # noqa: E501

        :param host_name: The host_name of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: str
        """
        if host_name is None:
            raise ValueError("Invalid value for `host_name`, must not be `None`")  # noqa: E501

        self._host_name = host_name

    @property
    def accept_self_signed_certificate(self):
        """Gets the accept_self_signed_certificate of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        Accept self signed certificate when connecting to vSphere  # noqa: E501

        :return: The accept_self_signed_certificate of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: bool
        """
        return self._accept_self_signed_certificate

    @accept_self_signed_certificate.setter
    def accept_self_signed_certificate(self, accept_self_signed_certificate):
        """Sets the accept_self_signed_certificate of this UpdateCloudAccountVsphereSpecification.

        Accept self signed certificate when connecting to vSphere  # noqa: E501

        :param accept_self_signed_certificate: The accept_self_signed_certificate of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: bool
        """

        self._accept_self_signed_certificate = accept_self_signed_certificate

    @property
    def associated_cloud_account_ids(self):
        """Gets the associated_cloud_account_ids of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        NSX-V or NSX-T account to associate with this vSphere cloud account. vSphere cloud account can be a single NSX-V cloud account or a single NSX-T cloud account.  # noqa: E501

        :return: The associated_cloud_account_ids of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: list[str]
        """
        return self._associated_cloud_account_ids

    @associated_cloud_account_ids.setter
    def associated_cloud_account_ids(self, associated_cloud_account_ids):
        """Sets the associated_cloud_account_ids of this UpdateCloudAccountVsphereSpecification.

        NSX-V or NSX-T account to associate with this vSphere cloud account. vSphere cloud account can be a single NSX-V cloud account or a single NSX-T cloud account.  # noqa: E501

        :param associated_cloud_account_ids: The associated_cloud_account_ids of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: list[str]
        """

        self._associated_cloud_account_ids = associated_cloud_account_ids

    @property
    def associated_mobility_cloud_account_ids(self):
        """Gets the associated_mobility_cloud_account_ids of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        Cloud account IDs and directionalities create associations to other vSphere cloud accounts that can be used for workload mobility. ID refers to an associated cloud account, and directionality can be unidirectional or bidirectional.  # noqa: E501

        :return: The associated_mobility_cloud_account_ids of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._associated_mobility_cloud_account_ids

    @associated_mobility_cloud_account_ids.setter
    def associated_mobility_cloud_account_ids(self, associated_mobility_cloud_account_ids):
        """Sets the associated_mobility_cloud_account_ids of this UpdateCloudAccountVsphereSpecification.

        Cloud account IDs and directionalities create associations to other vSphere cloud accounts that can be used for workload mobility. ID refers to an associated cloud account, and directionality can be unidirectional or bidirectional.  # noqa: E501

        :param associated_mobility_cloud_account_ids: The associated_mobility_cloud_account_ids of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: dict(str, str)
        """
        allowed_values = ["UNIDIRECTIONAL", "BIDIRECTIONAL"]  # noqa: E501
        if not set(associated_mobility_cloud_account_ids.keys()).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid keys in `associated_mobility_cloud_account_ids` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(associated_mobility_cloud_account_ids.keys()) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._associated_mobility_cloud_account_ids = associated_mobility_cloud_account_ids

    @property
    def dcid(self):
        """Gets the dcid of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors. Note: Data collector endpoints are not available in VMware Aria Automation (on-prem) release.  # noqa: E501

        :return: The dcid of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: str
        """
        return self._dcid

    @dcid.setter
    def dcid(self, dcid):
        """Sets the dcid of this UpdateCloudAccountVsphereSpecification.

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors. Note: Data collector endpoints are not available in VMware Aria Automation (on-prem) release.  # noqa: E501

        :param dcid: The dcid of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: str
        """

        self._dcid = dcid

    @property
    def username(self):
        """Gets the username of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        Username to authenticate with the cloud account. Not required when environment is set to aap.  # noqa: E501

        :return: The username of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this UpdateCloudAccountVsphereSpecification.

        Username to authenticate with the cloud account. Not required when environment is set to aap.  # noqa: E501

        :param username: The username of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def password(self):
        """Gets the password of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        Password for the user used to authenticate with the cloud Account. Not required when environment is set to aap.  # noqa: E501

        :return: The password of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this UpdateCloudAccountVsphereSpecification.

        Password for the user used to authenticate with the cloud Account. Not required when environment is set to aap.  # noqa: E501

        :param password: The password of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def regions(self):
        """Gets the regions of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.   # noqa: E501

        :return: The regions of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: list[IaasapicloudaccountsvsphereRegions]
        """
        return self._regions

    @regions.setter
    def regions(self, regions):
        """Sets the regions of this UpdateCloudAccountVsphereSpecification.

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.   # noqa: E501

        :param regions: The regions of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: list[IaasapicloudaccountsvsphereRegions]
        """
        if regions is None:
            raise ValueError("Invalid value for `regions`, must not be `None`")  # noqa: E501

        self._regions = regions

    @property
    def create_default_zones(self):
        """Gets the create_default_zones of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        Create default cloud zones for the enabled regions.  # noqa: E501

        :return: The create_default_zones of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: bool
        """
        return self._create_default_zones

    @create_default_zones.setter
    def create_default_zones(self, create_default_zones):
        """Sets the create_default_zones of this UpdateCloudAccountVsphereSpecification.

        Create default cloud zones for the enabled regions.  # noqa: E501

        :param create_default_zones: The create_default_zones of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: bool
        """

        self._create_default_zones = create_default_zones

    @property
    def tags(self):
        """Gets the tags of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        A set of tag keys and optional values to set on the Cloud Account  # noqa: E501

        :return: The tags of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this UpdateCloudAccountVsphereSpecification.

        A set of tag keys and optional values to set on the Cloud Account  # noqa: E501

        :param tags: The tags of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def certificate_info(self):
        """Gets the certificate_info of this UpdateCloudAccountVsphereSpecification.  # noqa: E501


        :return: The certificate_info of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: IaasapiintegrationsCertificateInfo
        """
        return self._certificate_info

    @certificate_info.setter
    def certificate_info(self, certificate_info):
        """Sets the certificate_info of this UpdateCloudAccountVsphereSpecification.


        :param certificate_info: The certificate_info of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: IaasapiintegrationsCertificateInfo
        """

        self._certificate_info = certificate_info

    @property
    def environment(self):
        """Gets the environment of this UpdateCloudAccountVsphereSpecification.  # noqa: E501

        The environment where data collectors are deployed. When the data collectors are deployed on an aap-based cloud gateway appliance, use \"aap\".  # noqa: E501

        :return: The environment of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :rtype: str
        """
        return self._environment

    @environment.setter
    def environment(self, environment):
        """Sets the environment of this UpdateCloudAccountVsphereSpecification.

        The environment where data collectors are deployed. When the data collectors are deployed on an aap-based cloud gateway appliance, use \"aap\".  # noqa: E501

        :param environment: The environment of this UpdateCloudAccountVsphereSpecification.  # noqa: E501
        :type: str
        """

        self._environment = environment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateCloudAccountVsphereSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateCloudAccountVsphereSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
